/*******************
Ad Format: In-Stream Video Interactive
Amazon Template Version: 1.0.0
Last Updated On: 2021-05-14
*******************/

/*******************
INITIALIZATION
*******************/
function checkIfAdKitReady(event) {
    adkit.onReady(initializeCreative);
}
function initializeCreative() {
    close_btn.style.visibility = "visible"; // Change the visibility property value to "hidden" if close_btn is not needed.
    skip_btn.style.visibility = "hidden";    
    if (close_btn.style.visibility == "hidden") {
        close_btn.style.marginTop = "-37px";     
    }
    // The "onSkipEnabled" function will run when the Skip is enabled within the Ad Setup Settings.
    adkit.vpaid.onSkipEnabled(function() {
        skip_btn.style.visibility = "visible";
        skip_btn.style.marginTop = "0px";
    });
    initializeEvents();
}
function initializeEvents() {    
    toggle_playback_btn.addEventListener("click", togglePlayback);
    toggle_audio_btn.addEventListener("click", toggleAudio);
    skip_btn.addEventListener("click", onClickSkip);
    close_btn.addEventListener("click", onClickClose);
    video_hotspot.addEventListener("click", onClickVideo);
    cta_btn.addEventListener("click", onClickCTA);
    user_action_btn.addEventListener("click", onClickUserAction);
    // The "onVideoEvents" function is for defining functionalities for specific video events.
    adkit.vpaid.onVideoEvents([adkit.vpaid.VIDEO_EVENTS.PLAY, adkit.vpaid.VIDEO_EVENTS.PAUSE, adkit.vpaid.VIDEO_EVENTS.ENDED], function(event) { 
        var html = event.type === "play" ? "pause" : "play";
        toggle_playback_btn.innerHTML = html.charAt(0).toUpperCase() + html.slice(1);
    });    
    adkit.vpaid.onVideoEvents([adkit.vpaid.VIDEO_EVENTS.VOLUME_CHANGE], function(event) { 
        var html = adkit.vpaid.muted ? "unmute" : "mute";
        toggle_audio_btn.innerHTML = html.charAt(0).toUpperCase() + html.slice(1);
    });
    // The "videoEvent" function is used for other video events if needed.
    adkit.vpaid.onVideoEvents(videoEvent);
}

/*******************
EVENT HANDLERS
*******************/
function togglePlayback(){
    if(toggle_playback_btn.innerHTML.toLowerCase() === "pause") {
        adkit.vpaid.pause();
        return;
    }
    adkit.vpaid.play();
}
function toggleAudio(){
    adkit.vpaid.muted = !adkit.vpaid.muted;
}
function onClickSkip(event) {
    adkit.vpaid.skipAd();
}
function onClickClose(event) {
    adkit.vpaid.closeAd();
}
function onClickVideo() {
    EB.clickthrough("Click_Video");
    adkit.vpaid.pause();
}
function onClickCTA() {
    EB.clickthrough("Click_CTA");
    adkit.vpaid.pause();
}
function onClickUserAction() {
    EB.userActionCounter("User_Action");
}
function videoEvent(event) {
    switch(event.type) {
        // Remove the comment tags below if close_btn is needed to be "visible" after 5 seconds of the video playing. Change the number of seconds if needed.
        /*case "timeupdate": 
            close_btn.style.marginTop = "0px"; 
            if(event.data.currentTime >= 5) {
                close_btn.style.visibility = "visible";
            }
            break;*/
    }
}

window.addEventListener("load", checkIfAdKitReady);